extern u8 DSP_MEM[0x100];

#define MIXBUFSIZE 256
extern u8 soundBuffer[MIXBUFSIZE * 2];
extern u32 curSoundBuffer;
void MixMono(u8 *outBuffer);

#define DSP_DEBUG
void DspReset();
void DspPrepareStateAfterReload();
void DspSetupMixer() CODE_IN_ROM;

typedef struct _DspChannel {
	u32 lowSpeed;
	u32 count;
	s16 *sample;
	s16 *sampleEnd;
	s16 *loopStart;
	u16 highSpeed;
	u16 pad;
	s8 volume;
	u8 active;
	u8 flags;
} __attribute__ ((aligned(4),packed)) DspChannel;

extern DspChannel channels[8] DATA_ALIGNED_EWRAM;

// DSP Register defintions

// Channel specific
#define DSP_VOL_L		0x00
#define DSP_VOL_R		0x01
#define DSP_PITCH_L		0x02
#define DSP_PITCH_H		0x03
#define DSP_SRC			0x04
#define DSP_ADSR1		0x05
#define DSP_ADSR2		0x06
#define DSP_GAIN		0x07
#define DSP_ENVX		0x08
#define DSP_OUTX		0x09

// Global
#define DSP_MAINVOL_L	0x0C
#define DSP_MAINVOL_R	0x1C
#define DSP_ECHOVOL_L	0x2C
#define DSP_ECHOVOL_R	0x3C
#define DSP_KON			0x4C
#define DSP_KOF			0x5C
#define DSP_FLAG		0x6C
#define DSP_ENDX		0x7C

#define DSP_EFB			0x0D
#define DSP_PMOD		0x2D
#define DSP_NOV			0x3D
#define DSP_EOV			0x4D
#define DSP_DIR			0x5D
#define DSP_ESA			0x6D
#define DSP_EDL			0x7D
